// ############################################################################
// Lockerfox
// ############################################################################

// This global variable is where all the script goes so that it doesn't polute the global namespace
//
var MYAPP = MYAPP || {};

MYAPP.run = (function() {

    // Create the Kendo UI Mobile application
    //
    MYAPP.app = new kendo.mobile.Application(document.body, {
        transition: "fade"
    });

    // Depends on the Device plugin included in config.xml.  This is a fix for the iphone's top status bar being overlayed by the
    // Kendo Mobile navbar on IOS7.  See http://docs.telerik.com/platform/appbuilder/troubleshooting/ios7-status-bar#solution-one
    //
    if (device.platform === 'iOS' && parseFloat(device.version) >= 7.0) {
        document.body.style.marginTop = "20px";
    }

    MYAPP.profile = {};

    // We POST and get back JSON from these endpoints provided by Processwire
    //

//    MYAPP.login_url =        "https://dev.lockerfox.com/account/mobile-api/login/";
//    MYAPP.auction_list_url = "https://dev.lockerfox.com/account/mobile-api/auction-list/";
//    MYAPP.my_account_url =   "https://dev.lockerfox.com/account/mobile-api/my-account/";
//    MYAPP.auction_url =      "https://dev.lockerfox.com/account/mobile-api/auction-controller/";
//    MYAPP.bid_url =          "https://dev.lockerfox.com/account/bid/";
//    MYAPP.firebase_url =     "https://ebidsa-dev.firebaseio.com/";

    MYAPP.login_url =        "https://www.lockerfox.com/account/mobile-api/login/";
    MYAPP.auction_list_url = "https://www.lockerfox.com/account/mobile-api/auction-list/";
    MYAPP.my_account_url =   "https://www.lockerfox.com/account/mobile-api/my-account/";
    MYAPP.auction_url =      "https://www.lockerfox.com/account/mobile-api/auction-controller/";
    MYAPP.bid_url =          "https://www.lockerfox.com/account/bid/";
    MYAPP.firebase_url =     "https://ebidsa.firebaseio.com/";

    MYAPP.authenticated = false;

    MYAPP.firebase = new Firebase(MYAPP.firebase_url);

    $.ajaxSetup({
        type: "POST",
        contentType: "application/json; charset=utf-8",
        dataType: "json",
        error: function(response) {
            MYAPP.app.navigate("#login");
            $("#modalview-login").kendoMobileModalView("open");
            $('#login-error-message-item').toggle(true);
            $("#login-error-message").html("Unable to connect to Lockerfox");
        }
    });

    $(document).ajaxStart(function() {
        MYAPP.app.showLoading()
    });
    $(document).ajaxStop(function() {
        MYAPP.app.hideLoading()
    });

    //hideTabStrip();

    if (supports_html5_storage()) {
        var username = window.localStorage.getItem('username');
        var password = window.localStorage.getItem('password');

        if (username && password) {
            if (username.length > 0 && password.length > 0) {
                $('#username').val(username);
                $('#password').val(password);
                setTimeout(function() { authenticateOnLaunch(username, password) }, 2000);
            }
        }
    }

});

// This function runs at startup and attaches to the 'deviceready' event
// which is fired by PhoneGap when the hardware is ready for native API
// calls. It is self invoking and will run immediately when this script file is 
// loaded.
//
(function() {
    // Attach to deviceready event, which is fired when phonegap is all good to go.
    //
    document.addEventListener('deviceready', MYAPP.run, false);
})();

// This is called when the intial view shows. it prevents the flash of unstyled content (FOUC)
//
MYAPP.show = (function() {

    $(document.body).show();

    $('#login-error-message-item').toggle(false);

    hideTabStrip();

});

////////////////////////////////////////////////////////////////////////////////
// Utility functions
////////////////////////////////////////////////////////////////////////////////
//
function supports_html5_storage() {
    return true;

    if(typeof(Storage) !== "undefined") {
        return true;
    } else {
        return false;
    }
}

function logout() {
    if (supports_html5_storage()) {
        window.localStorage.clear();
    }

    MYAPP.authenticated = false;
    MYAPP.app.navigate("#login");

    $('#login input').val('');

    hideTabStrip();

}

function showTabStrip(){
    $(".km-tabstrip").show();
}

function hideTabStrip(){
    $(".km-tabstrip").hide();
}

// ############################################################################
//                             AUCTION LIST
// ############################################################################
//
function auctionListInit() {

    auctionListDatasource = new kendo.data.DataSource({
        transport: {
            read: {
                url: MYAPP.auction_list_url,
                dataType: "json",
                complete: function(data, status) {

                    // We need to iterate the ListView's DOM to attach the Firebase "on value" handlers.  We can do it here
                    // because the AJAX sucess handler (apparently) draws the ListView, so by the time complete fires, the DOM
                    // is ready.  See http://stackoverflow.com/questions/20846315/how-to-detect-that-grid-rows-have-been-created-in-a-kendo-ui-grid
                    //
                    if (status === "success") {
                        attachAuctionListFirebaseBindings($('.auction-list-template-item-high-bid.all .high-bid'), $('.auction-list-template-item-high-bid.all .high-bidder'));
                    }
                }
            },
            parameterMap: function(data, type) {
                return kendo.stringify({
                    request: {
                        action: "FETCH_ALL"
                    }
                });
            }
        },
        schema: {
            data: "results" // The data which the data source will be bound to is in the "results" field
        }
    });

    $("#auction-list-ul").kendoMobileListView({
        dataSource: auctionListDatasource,
        pullToRefresh: true,
        template: $("#auction-list-template").text(),
        dataBound: function(e) {
            if(this.dataSource.data().length == 0){
                $("#auction-list-empty-overlay").show();
            } else {
                $("#auction-list-empty-overlay").hide();
            }
        }
    });
}

function auctionListRefresh() {
    auctionListDatasource.read();
}

// ############################################################################
//                             MY AUCTION LIST
// ############################################################################
//
function myAuctionListInit() {

    myAuctionListDatasource = new kendo.data.DataSource({
        transport: {
            read: {
                url: MYAPP.auction_list_url,
                dataType: "json",
                complete: function(data, status) {

                    // We need to iterate the ListView's DOM to attach the Firebase "on value" handlers.  We can do it here
                    // because the AJAX sucess handler (apparently) draws the ListView, so by the time complete fires, the DOM
                    // is ready.  See http://stackoverflow.com/questions/20846315/how-to-detect-that-grid-rows-have-been-created-in-a-kendo-ui-grid
                    //
                    if (status === "success") {
                        attachAuctionListFirebaseBindings($('.auction-list-template-item-high-bid.mine .high-bid'), $('.auction-list-template-item-high-bid.mine .high-bidder'));
                    }
                }
            },
            parameterMap: function(data, type) {
                return kendo.stringify({
                    request: {
                        action: "FETCH_MY"
                    }
                });
            }
        },
        schema: {
            data: "results" // The data which the data source will be bound to is in the "results" field
        }
    });

    $("#my-auction-list-ul").kendoMobileListView({
        dataSource: myAuctionListDatasource,
        pullToRefresh: true,
        template: $("#my-auction-list-template").text(),
        dataBound: function(e) {
            if(this.dataSource.data().length == 0){
                $("#my-auction-list-empty-overlay").show();
            } else {
                $("#my-auction-list-empty-overlay").hide();
            }
        }
    });

}

function myAuctionListRefresh() {
    myAuctionListDatasource.read();
}

// ############################################################################
//                             AUCTION DETAIL
// ############################################################################
//
function auctionDetailShow(e) {

    if (!e.view.params.auction_id) {
        return;
    }

    $.ajax({
        url: MYAPP.auction_url,
        data:  JSON.stringify(
            {
                "request": {
                    "action": "DETAIL"
                },
                "params": {
                    auction_id: e.view.params.auction_id
                }
            }),
        success: function(response) {
            if (response.status == "OK") {

                // This is used in the placeBid
                //
                MYAPP.current_auction_id = e.view.params.auction_id;

                $('#auction-detail-lot-number').text(response.lot_number);
                $('#auction-detail-facility-title').text(response.facility_title);
                $('#auction-detail-cover-thumbnail img').attr('src', response.cover_url);
                $('#auction-detail-inventory-tags').text(response.inventory_tags);
                $('#auction-detail-unit-details').html(response.unit_details);
                $('#auction-detail-facility-information').html(response.facility_information);
                $('#auction-detail-policy-statement').html(response.policy_statement);
                $('#auction-detail-facility_location').html(response.facility_location);
                $('#auction-detail-notes').html(response.notes);

                var navbar = MYAPP.app.view()
                    .header
                    .find(".km-navbar")
                    .data("kendoMobileNavBar");

                navbar.title("Lot #" + response.lot_number);

                if (response.images.length) {
                    var div = $('#auction-detail-images').empty();
                    $.each(response.images, function(prop, val) {
                        div.append('<img src="' + val + '"></img>');
                    });
                }

                attachAuctionDetailFirebaseBindings(e.view.params.auction_id);
            }
        }
    });
}

function auctionDetailInit() {

    // Normally this would create a datasource and bind it to a ListGrid, but the
    // auction detail view is just an HTML screen with values returned from auctionDetailShow().

}

// ############################################################################
//                             MY BIDS
// ############################################################################
//
function myBidsListInit() {

    myBidsListDatasource = new kendo.data.DataSource({
        transport: {
            read: {
                url: MYAPP.my_account_url,
                dataType: "json"
            },
            parameterMap: function(data, type) {
                return kendo.stringify({
                    request: {
                        action: "BIDS"
                    }
                });
            }
        },
        schema: {
            data: "data" // The data which the data source will be bound to is in the "results" field
        }
    });

    $("#my-bids-list-ul").kendoMobileListView({
        dataSource: myBidsListDatasource,
        pullToRefresh: true,
        template: $("#my-bids-list-template").text(),
        dataBound: function(e) {
            if(this.dataSource.data().length == 0){
                $("#my-bids-list-empty-overlay").show();
            } else {
                $("#my-bids-list-empty-overlay").hide();
            }
        }
    });

}

function myAuctionListRefresh() {
    // What if no records come back?  How to show a nice message?  See
    // http://stackoverflow.com/questions/23085661/how-can-i-show-no-results-in-kendo-mobile-listview
    //
    if (typeof variable !== 'undefined') {
        myBidsListDatasource.read();
    }
}

// ############################################################################
//                             MY ACCOUNT
// ############################################################################
//
function myAccountShow(e) {

    $.ajax({
        url: MYAPP.my_account_url,
        data:  JSON.stringify(
            {
                "request": {
                    "action": "FETCH"
                }
            }),
        success: function(response) {
            if (response.status == "OK") {

                $('#nickname').text(response.data.nickname);
                $('#number_of_bids').text(response.data.number_of_bids);
                $('#number_of_wins').text(response.data.number_of_wins);

            }
        }
    });
}

// ############################################################################
//                             FIREBASE INTEGRATION
// ############################################################################
//
function attachAuctionListFirebaseBindings(bid_nodes, bidder_nodes) {
    bid_nodes.each(function() {
        // Closure for span_id
        //
        var span_id = $(this).attr('id');
        var auction_id = $(this).attr('id').split('_')[1];

        // Closure so firebase callback can find the span
        //
        var span = $(this);

        // Unbind previously bound on handlers, otherwise pull to refresh will create multiple bindings
        //
        MYAPP.firebase.child('auctions/' + auction_id + '/bid').off();

        MYAPP.firebase.child('auctions/' + auction_id + '/bid').on('value', function(snapshot) {
            $(span).html("<b>$</b><b>" + snapshot.val().split('').join("</b> <b>") + "</b>");

        });
    });

    bidder_nodes.each(function() {

        // Closure for span_id
        //
        var span_id = $(this).attr('id');
        var auction_id = $(this).attr('id').split('_')[1];

        // Closure so firebase callback can find the span
        var span = $(this);

        // Unbind previously bound on handlers, otherwise pull to refresh will create multiple bindings
        //
        MYAPP.firebase.child('auctions/' + auction_id + '/current_bidder_nickname').off();

        MYAPP.firebase.child('auctions/' + auction_id + '/current_bidder_nickname').on('value', function(snapshot) {
            $(span).html(snapshot.val());

        });

    });
}

function attachAuctionDetailFirebaseBindings(auction_id) {

    // Unbind previously bound on handlers, otherwise pull to refresh will create multiple bindings
    //
    MYAPP.firebase.child('auctions/' + auction_id + '/countdown').off();

    MYAPP.firebase.child('auctions/' + auction_id + '/countdown').on('value', function(snapshot) {

        var seconds = snapshot.val();

        if (snapshot.val() <= 300) {
            $('#ddhhmm-countdown').hide();
            $('#hhmmss-countdown').show();
        }

        if (snapshot.val() > 300) {
            $('#ddhhmm-countdown').show();
            $('#hhmmss-countdown').hide();
        }

        var days = parseInt( Math.floor(seconds / 86400) );
        var dd = (days < 10 ? new String("0") + new String(days) : new String(days));
        $('.countdown-days').html("<b>" + dd.split('').join("</b> <b>") + "</b>");

        var hours = parseInt( Math.floor(seconds / 3600)) % 24;
        var hh = (hours < 10 ? new String("0") + new String(hours) : new String(hours));
        $('.countdown-hours').html("<b>" + hh.split('').join("</b> <b>") + "</b>");

        var minutes = parseInt( seconds / 60 ) % 60;
        var mm = (minutes < 10 ? new String("0") + new String(minutes) : new String(minutes));
        $('.countdown-minutes').html("<b>" + mm.split('').join("</b> <b>") + "</b>");

        var seconds = parseInt( seconds % 60);
        var ss = (seconds < 10 ? new String("0") + new String(seconds) : new String(seconds));
        $('.countdown-seconds').html("<b>" + ss.split('').join("</b> <b>") + "</b>");

    });

    // Unbind previously bound on handlers, otherwise pull to refresh will create multiple bindings
    //
    MYAPP.firebase.child('auctions/' + auction_id + '/bid').off();

    MYAPP.firebase.child('auctions/' + auction_id + '/bid').on('value', function(snapshot) {
        $('#auction-detail-high-bid-value').html("<b>$</b><b>" + snapshot.val().split('').join("</b> <b>") + "</b>");

        // Update the bid button to reflect the next highest (+20) bid.  MYAPP.next_bid is also used
        // in the bid button callback (placeBid)
        //
        MYAPP.next_bid = parseInt(snapshot.val()) + 20;

        $('#bid-button').html('Bid <b>$' + MYAPP.next_bid + '</b>');

    });

    MYAPP.firebase.child('auctions/' + auction_id + '/bidders').off();

    $('#bidder-list').empty();

    MYAPP.firebase.child('auctions/' + auction_id + '/bidders').on('child_added', function(snapshot) {
        var msgData = snapshot.val();

        $('#bidder-list').prepend('<div style="margin-bottom: 10px;" class="bidder-list-row"><div class="bidder-list-column">' + msgData.date + '</div><div class="bidder-list-column">$' + msgData.bid + '</div><div class="bidder-list-column">' + msgData.user + '</div></div>');

        $('#bidder-list .bidder-list-row').css({"color": "", "font-weight": "normal"});

        $('#bidder-list .bidder-list-row:first-child').css({"color": "#4CBA19", "font-weight": "bold"});
    });

}

// ############################################################################
//                         POST A BID TO THE SERVER
// ############################################################################
//
function placeBid() {

    swal({
            title: "Confirm $" + MYAPP.next_bid + " Bid",
            text: "Are you sure you want to place this bid?  This is an agreement to purchase the contents of this unit for $" + MYAPP.next_bid + ", if you are the winning bidder.  YOU WILL NEED TO PICK UP IN-PERSON AT THE FACILITY.",

            showCancelButton: true,
            confirmButtonColor: "#4cba19",
            confirmButtonText: "Yes, place bid!",
            closeOnConfirm: true
        },
        function(){
            // Place bid via AJAX.  Not that since this is an app, the request is "cross-domain" and jquery won't
            // send the requested-with-ajax header by default, we need to force it.  The middle tier validates that
            // the bid request comes in via AJAX.
            //
            // Also, in ajaxSetup, we default ajax calls to be contentType json, but in this case, so we can use the same bid endpoint as the
            // web site, we need to set this to form encoded.
            //
            //
            var formData = {id: MYAPP.current_auction_id, bid: MYAPP.next_bid, bid_source: 'M' };

            $.ajax({
                url : MYAPP.bid_url,
                headers: {'X-Requested-With': 'XMLHttpRequest'},
                contentType: 'application/x-www-form-urlencoded; charset=UTF-8',
                data : formData,
                success: function(data, textStatus, jqXHR)
                {
                    if (data.status == "ERROR") {
                        swal({
                            title: "Oh Snap!",
                            text: data.message,
                            type: "error",
                            confirmButtonColor: "#0961BA"
                        });
                    }
                },
                error: function (jqXHR, textStatus, errorThrown)
                {
                    swal({
                        title: "Oh Snap!",
                        text: "Your bid was not placed due to an error.  Don't worry, it's no you.  It's us.  We'll look into it!",
                        type: "error",
                        confirmButtonColor: "#0961BA"
                    });
                }
            });
        });
}

// ############################################################################
//                         LOGIN HANDLING / AUTHENTICATION
// ############################################################################
//
// This is called when the app launches, and it differs from authenticate() in
// that it doesn't show the spinner, and on failure it brings up the login dialog
// to prompt for proper credentials
//
function authenticateOnLaunch(username, password) {

    $('#launch-progress').html("Logging in...");

    $.ajax({
        url: MYAPP.login_url,
        data:  JSON.stringify(
            {
                "request": {
                    "action": "auth"
                },
                "params": {
                    "username": username,
                    "password": password
                }
            }
        ),
        success: function(response) {
            if (response.status == "OK") {
                MYAPP.profile = response.profile;
                MYAPP.app.navigate("#auction-list");
                showTabStrip();
            } else {
                MYAPP.app.navigate("#login");
                $("#modalview-login").kendoMobileModalView("open");
                $('#login-error-message-item').toggle(true);
                $("#login-error-message").html(response.message);
            }
        }
    });

}

function authenticateInteractive() {

    var username = $('#username').val();
    var password = $('#password').val();

    $.ajax({
        url: MYAPP.login_url,
        data:  JSON.stringify(
            {
                "request": {
                    "action": "auth"
                },
                "params": {
                    "username": username,
                    "password": password
                }
            }),
        success: function(response) {
            if (response.status == "OK") {

                MYAPP.profile.user_id = response.user_id;
                window.localStorage.setItem('username', username);
                window.localStorage.setItem('password', password);
                MYAPP.app.navigate("#auction-list");
                showTabStrip();
            } else {
                $('#login-error-message-item').toggle(true);
                $("#login-error-message").html(response.message);
                $('#username').focus();
            }
        }
    });

}
